C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE L6TO9     *****                   *
C  *                                                                          *
C  *    MAIN LOOP FOR FACTORS NOT EQUAL TO TWO.  APPLY THE TWIDDLE FACTOR     *
C  *     W=EXP(ISIGN*2*PI*SQRT(-1)*(J2-1)*(J1-J2)/(NP2*IFP1)), THEN           *
C  *     PERFORM A FOURIER TRANSFORM OF LENGTH IFACT(IF), MAKING USE OF       *
C  *     CONJUGATE SYMMETRIES.                                                *
C  ****************************************************************************
C
      SUBROUTINE L6TO9 (DATA, NN, NDIM, KSIGN, IFORM, WORK, NTWO,
     1  NPT2, NP2, NP0, KSTEP, I1MAX, IFACT, NON2, IF, NP1, ICASE,
     2  THETA, TWOPI, WSTPR, WSTPI, WR, WI, I1RNG, I1, I3, NTOT,
     3  J3, TEMPR, N, KMIN, TEMPI, I2, J, I, IDIM)
C
      DIMENSION DATA(1), NN(1), IFACT(32), WORK(1)
C  ---------------------------------------------------------------------------
C
  600      IF(NTWO-NP2)605,700,700      
  605      IFP1  = NON2  
      IF    = 1  
      NP1HF = NP1/2
  610      IFP2  = IFP1/IFACT(IF)  
      J1RNG = NP2  
      IF(ICASE-3)612,611,612
  611      J1RNG = (NP2+IFP1)/2   
      J2STP = NP2/IFACT(IF)  
      J1RG2 = (J2STP+IFP2)/2 
  612      J2MIN = 1+IFP2  
      IF(IFP1-NP2)615,640,640      
  615      DO 635 J2 = J2MIN,IFP1,IFP2    
        THETA = -TWOPI*FLOAT(J2-1)/FLOAT(NP2)  
        IF (KSIGN) 625,620,620
  620        THETA = -THETA  
  625        SINTH = SIN(THETA/2.)  
        WSTPR = -2.*SINTH*SINTH
        WSTPI = SIN(THETA)     
        WR    = WSTPR+1.
        WI    = WSTPI   
        J1MIN = J2+IFP1 
        DO 635 J1 = J1MIN,J1RNG,IFP1   
          I1MAX = J1+I1RNG-2     
          DO I1 = J1,I1MAX,2 
            DO I3 = I1,NTOT,NP2
            J3MAX = I3+IFP2-NP1    
              DO J3 = I3,J3MAX,NP1
                TEMPR = DATA(J3)
                DATA(J3) = DATA(J3)*WR-DATA(J3+1)*WI
                DATA(J3+1) = TEMPR*WI+DATA(J3+1)*WR
              ENDDO
            ENDDO
          ENDDO
        TEMPR = WR
        WR    = WR*WSTPR-WI*WSTPI+WR
  635      WI    = TEMPR*WSTPI+WI*WSTPR+WI
  640      THETA = -TWOPI/FLOAT(IFACT(IF))
      IF (KSIGN) 650,645,645
  645      THETA = -THETA
  650      SINTH = SIN(THETA/2.)
      WSTPR = -2.*SINTH*SINTH
      WSTPI = SIN(THETA)
      KSTEP = 2*N/IFACT(IF)
      KRANG = KSTEP*(IFACT(IF)/2)+1
      DO 698 I1 = 1,I1RNG,2
      DO 698 I3 = I1,NTOT,NP2
        DO 690 KMIN = 1,KRANG,KSTEP
        J1MAX = I3+J1RNG-IFP1
        DO 680 J1 = I3,J1MAX,IFP1
          J3MAX = J1+IFP2-NP1
          DO 680 J3 = J1,J3MAX,NP1
            J2MAX = J3+IFP1-IFP2
            K     = KMIN+(J3-J1+(J1-I3)/IFACT(IF))/NP1HF
            IF(KMIN-1)655,655,665
  655            SUMR = 0.0
            SUMI = 0.0
            DO J2 = J3,J2MAX,IFP2
              SUMR = SUMR+DATA(J2)
              SUMI = SUMI+DATA(J2+1)
            ENDDO
            WORK(K)   = SUMR
            WORK(K+1) = SUMI
            GO TO 680  
  665            KCONJ = K+2*(N-KMIN+1) 
            J2    = J2MAX   
            SUMR  = DATA(J2) 
            SUMI  = DATA(J2+1)
            OLDSR = 0.0
            OLDSI = 0.0
            J2    = J2-IFP2
  670            TEMPR = SUMR
            TEMPI = SUMI
            SUMR  = TWOWR*SUMR-OLDSR+DATA(J2)
            SUMI  = TWOWR*SUMI-OLDSI+DATA(J2+1)
            OLDSR = TEMPR
            OLDSI = TEMPI
            J2    = J2-IFP2
             IF(J2-J3)675,675,670
  675            TEMPR         = WR*SUMR-OLDSR+DATA(J2)
            TEMPI         = WI*SUMI
            WORK(K)       = TEMPR-TEMPI
            WORK(KCONJ)   = TEMPR+TEMPI
            TEMPR         = WR*SUMI-OLDSI+DATA(J2+1)
            TEMPI         = WI*SUMR
            WORK(K+1)     = TEMPR+TEMPI
            WORK(KCONJ+1) = TEMPR-TEMPI
  680        CONTINUE
        IF(KMIN-1)685,685,686
  685        WR = WSTPR+1.0
        WI = WSTPI
        GO TO 690
  686        TEMPR=WR
        WR    = WR*WSTPR-WI*WSTPI+WR
        WI    = TEMPR*WSTPI+WI*WSTPR+WI
  690      TWOWR = WR+WR
      IF(ICASE-3)692,691,692
  691      IF(IFP1-NP2)695,692,692
  692      K     = 1
      I2MAX = I3+NP2-NP1
      DO I2 = I3,I2MAX,NP1
        DATA(I2)   = WORK(K)
        DATA(I2+1) = WORK(K+1)
        K          = K+2
      ENDDO
      GO TO 698
C  *******************************************************************
C  *    COMPLETE A REAL TRANSFORM IN THE 1ST DIMENSION, N ODD, BY    *
C  *     CONJUGATE SYMMETRIES AT EACH STAGE.                         *
C  *******************************************************************
  695      J3MAX = I3+IFP2-NP1
      DO 697 J3 = I3,J3MAX,NP1
        J2MAX = J3+NP2-J2STP
        DO 697 J2 = J3,J2MAX,J2STP
          J1MAX = J2+J1RG2-IFP2
          J1CNJ = J3+J2MAX+J2STP-J2
          DO 697 J1 = J2,J1MAX,IFP2
            K          = 1+J1-I3
            DATA(J1)   = WORK(K)
            DATA(J1+1) = WORK(K+1)
            IF(J1-J2)697,697,696
  696            DATA(J1CNJ)   =  WORK(K)
            DATA(J1CNJ+1) = -WORK(K+1)
  697            J1CNJ         = J1CNJ-IFP2
  698      CONTINUE
      IF    = IF+1
      IFP1  = IFP2
      IF(IFP1-NP1)700,700,610
C  ********************************************************************
C  *    COMPLETE A REAL TRANSFORM IN THE 1ST DIMENSION, N EVEN, BY    *
C  *     CONJUGATE SYMMETRIES.                                        *
C  ********************************************************************
  700      GO TO (900,800,900,701),ICASE
  701      NHALF = N
      N     = N+N
      THETA = -TWOPI/FLOAT(N)
      IF (KSIGN) 703,702,702
  702      THETA = -THETA
  703      SINTH = SIN(THETA/2.)
      WSTPR = -2.*SINTH*SINTH
      WSTPI = SIN(THETA)
      WR    = WSTPR+1.0
      WI    = WSTPI
      IMIN  = 3
      JMIN  = 2*NHALF-1
      GO TO 725
  710      J = JMIN
      DO I = IMIN,NTOT,NP2
        SUMR      = (DATA(I)  +DATA(J))  /2.
        SUMI      = (DATA(I+1)+DATA(J+1))/2.
        DIFR      = (DATA(I)  -DATA(J))  /2.
        DIFI      = (DATA(I+1)-DATA(J+1))/2.
        TEMPR     = WR*SUMI+WI*DIFR
        TEMPI     = WI*SUMI-WR*DIFR
        DATA(I)   = SUMR+TEMPR
        DATA(I+1) = DIFI+TEMPI
        DATA(J)   = SUMR-TEMPR
        DATA(J+1) = -DIFI+TEMPI
        J         = J+NP2
      ENDDO
      IMIN  = IMIN+2
      JMIN  = JMIN-2
      TEMPR = WR
      WR    = WR*WSTPR-WI*WSTPI+WR
      WI    = TEMPR*WSTPI+WI*WSTPR+WI
  725      IF(IMIN-JMIN)710,730,740
  730      IF (KSIGN) 731,740,740
  731      DO I = IMIN,NTOT,NP2
        DATA(I+1) = -DATA(I+1)
      ENDDO
  740      NP2  = NP2+NP2
      NTOT = NTOT+NTOT
      J    = NTOT+1
      IMAX = NTOT/2+1
  745      IMIN = IMAX-2*NHALF
      I    = IMIN
      GO TO 755
  750      DATA(J)   =  DATA(I)
      DATA(J+1) = -DATA(I+1)
  755      I         = I+2
      J         = J-2
      IF(I-IMAX)750,760,760
  760      DATA(J)   = DATA(IMIN)-DATA(IMIN+1)
      DATA(J+1) = 0.0
      IF(I-J)770,780,780
  765      DATA(J)   = DATA(I)
      DATA(J+1) = DATA(I+1)
  770      I         = I-2
      J         = J-2
      IF(I-IMIN)775,775,765
  775      DATA(J)   = DATA(IMIN)+DATA(IMIN+1)
      DATA(J+1) = 0.0
      IMAX      = IMIN
      GO TO 745
  780      DATA(1) = DATA(1)+DATA(2)
      DATA(2) = 0.0
      GO TO 900
C  *******************************************************************
C  *    COMPLETE A REAL TRANSFORM FOR THE 2ND OR 3RD DIMENSION BY    *
C  *     CONJUGATE SYMMETRIES.                                       *
C  *******************************************************************
  800      IF(I1RNG-NP1)805,900,900
  805      DO I3 = 1,NTOT,NP2
        I2MAX = I3+NP2-NP1
        DO I2 = I3,I2MAX,NP1
          IMIN = I2+I1RNG
          IMAX = I2+NP1-2
          JMAX = 2*I3+NP1-IMIN
          IF(I2-I3)820,820,810
  810          JMAX = JMAX+NP2
  820          IF(IDIM-2)850,850,830
  830          J = JMAX+NP0
          DO I = IMIN,IMAX,2
            DATA(I)   =  DATA(J)
            DATA(I+1) = -DATA(J+1)
            J         = J-2
          ENDDO
  850          J = JMAX
          DO I = IMIN,IMAX,NP0
            DATA(I)   =  DATA(J)
            DATA(I+1) = -DATA(J+1)
            J         = J-NP0
          ENDDO
        ENDDO
      ENDDO
  900      RETURN
      END
